// ==============================================================
// Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC v2020.1.1 (64-bit)
// Copyright 1986-2020 Xilinx, Inc. All Rights Reserved.
// ==============================================================
#ifndef XACCUMULATE_ACCEL_H
#define XACCUMULATE_ACCEL_H

#ifdef __cplusplus
extern "C" {
#endif

/***************************** Include Files *********************************/
#ifndef __linux__
#include "xil_types.h"
#include "xil_assert.h"
#include "xstatus.h"
#include "xil_io.h"
#else
#include <stdint.h>
#include <assert.h>
#include <dirent.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stddef.h>
#endif
#include "xaccumulate_accel_hw.h"

/**************************** Type Definitions ******************************/
#ifdef __linux__
typedef uint8_t u8;
typedef uint16_t u16;
typedef uint32_t u32;
#else
typedef struct {
    u16 DeviceId;
    u32 Control_BaseAddress;
} XAccumulate_accel_Config;
#endif

typedef struct {
    u32 Control_BaseAddress;
    u32 IsReady;
} XAccumulate_accel;

/***************** Macros (Inline Functions) Definitions *********************/
#ifndef __linux__
#define XAccumulate_accel_WriteReg(BaseAddress, RegOffset, Data) \
    Xil_Out32((BaseAddress) + (RegOffset), (u32)(Data))
#define XAccumulate_accel_ReadReg(BaseAddress, RegOffset) \
    Xil_In32((BaseAddress) + (RegOffset))
#else
#define XAccumulate_accel_WriteReg(BaseAddress, RegOffset, Data) \
    *(volatile u32*)((BaseAddress) + (RegOffset)) = (u32)(Data)
#define XAccumulate_accel_ReadReg(BaseAddress, RegOffset) \
    *(volatile u32*)((BaseAddress) + (RegOffset))

#define Xil_AssertVoid(expr)    assert(expr)
#define Xil_AssertNonvoid(expr) assert(expr)

#define XST_SUCCESS             0
#define XST_DEVICE_NOT_FOUND    2
#define XST_OPEN_DEVICE_FAILED  3
#define XIL_COMPONENT_IS_READY  1
#endif

/************************** Function Prototypes *****************************/
#ifndef __linux__
int XAccumulate_accel_Initialize(XAccumulate_accel *InstancePtr, u16 DeviceId);
XAccumulate_accel_Config* XAccumulate_accel_LookupConfig(u16 DeviceId);
int XAccumulate_accel_CfgInitialize(XAccumulate_accel *InstancePtr, XAccumulate_accel_Config *ConfigPtr);
#else
int XAccumulate_accel_Initialize(XAccumulate_accel *InstancePtr, const char* InstanceName);
int XAccumulate_accel_Release(XAccumulate_accel *InstancePtr);
#endif

void XAccumulate_accel_Start(XAccumulate_accel *InstancePtr);
u32 XAccumulate_accel_IsDone(XAccumulate_accel *InstancePtr);
u32 XAccumulate_accel_IsIdle(XAccumulate_accel *InstancePtr);
u32 XAccumulate_accel_IsReady(XAccumulate_accel *InstancePtr);
void XAccumulate_accel_EnableAutoRestart(XAccumulate_accel *InstancePtr);
void XAccumulate_accel_DisableAutoRestart(XAccumulate_accel *InstancePtr);

void XAccumulate_accel_Set_img_in1_V(XAccumulate_accel *InstancePtr, u32 Data);
u32 XAccumulate_accel_Get_img_in1_V(XAccumulate_accel *InstancePtr);
void XAccumulate_accel_Set_img_in2_V(XAccumulate_accel *InstancePtr, u32 Data);
u32 XAccumulate_accel_Get_img_in2_V(XAccumulate_accel *InstancePtr);
void XAccumulate_accel_Set_img_out_V(XAccumulate_accel *InstancePtr, u32 Data);
u32 XAccumulate_accel_Get_img_out_V(XAccumulate_accel *InstancePtr);
void XAccumulate_accel_Set_height(XAccumulate_accel *InstancePtr, u32 Data);
u32 XAccumulate_accel_Get_height(XAccumulate_accel *InstancePtr);
void XAccumulate_accel_Set_width(XAccumulate_accel *InstancePtr, u32 Data);
u32 XAccumulate_accel_Get_width(XAccumulate_accel *InstancePtr);

void XAccumulate_accel_InterruptGlobalEnable(XAccumulate_accel *InstancePtr);
void XAccumulate_accel_InterruptGlobalDisable(XAccumulate_accel *InstancePtr);
void XAccumulate_accel_InterruptEnable(XAccumulate_accel *InstancePtr, u32 Mask);
void XAccumulate_accel_InterruptDisable(XAccumulate_accel *InstancePtr, u32 Mask);
void XAccumulate_accel_InterruptClear(XAccumulate_accel *InstancePtr, u32 Mask);
u32 XAccumulate_accel_InterruptGetEnabled(XAccumulate_accel *InstancePtr);
u32 XAccumulate_accel_InterruptGetStatus(XAccumulate_accel *InstancePtr);

#ifdef __cplusplus
}
#endif

#endif
